=== gavv/httpexpect@v2.0.0+incompatible/Makefile ===
all: update test check

update:
	go get -u -t . ./_examples

test:
	go test . ./_examples

check:
	golangci-lint run ./...

fmt:
	gofmt -s -w . ./_examples
